// Copyright 2020 Seiko Epson Corporation.
// Epson Europe
// EEB/RDC
// 2020/12  ka
// This Application is intended for demonstration purposes only and not for production environment.

#pragma once
#include <vector>
#include <windows.h>
#include "TSELogger.h"

class AccessSerial
{
public:
	AccessSerial(const char *  tPortName, TSELogger& tLog);
	~AccessSerial();
	void SerialSend(const std::vector<BYTE>& tBuffer);
	void SerialRecv(std::vector<BYTE>& tBuffer, const unsigned long& tMaxSize, const int& tTimeout);

private:
	HANDLE mPort;
	BOOL SerialIsOpen();
	void SerialClose();
	TSELogger& mLog;
};

//EOF